Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultPRJFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultPRJFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultPRJFile.java	(revision 43867)
@@ -0,0 +1,89 @@
+
+package org.gvsig.fmap.dal.fileutils.impl;
+
+import org.gvsig.fmap.dal.fileutils.PRJFile;
+import java.io.File;
+import java.io.IOException;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.cresques.cts.ICRSFactory;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.crs.CRSFactory;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class DefaultPRJFile implements PRJFile {
+            
+    private static final Logger logger = LoggerFactory.getLogger(DefaultPRJFile.class);
+    
+        
+    private File source;
+    private IProjection crs;
+    
+    public DefaultPRJFile() {
+        this.source = null;
+        this.crs = null;        
+    }
+    
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public DefaultPRJFile(File file) {
+        this();
+        this.read(file);
+    }
+    
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath())+"."+FILE_EXTENSION);
+        return f;
+    }
+    
+    @Override
+    public File getFile() {
+        return source;
+    }
+    
+    @Override
+    public IProjection getCRS() {
+        return this.crs;
+    }
+    
+    @Override
+    public void setCRS(IProjection crs) {
+        this.crs = crs;
+    }
+    
+    @Override
+    public void read(File file) {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                String theContents = FileUtils.readFileToString(f);
+                if (StringUtils.isNotEmpty(theContents)){
+                    IProjection theCrs=CRSFactory.getCRSFactory().get(ICRSFactory.FORMAT_WKT_ESRI, theContents);
+                    this.crs = theCrs;
+                    this.source = f.getAbsoluteFile();
+                }
+            } catch (IOException e) {
+                logger.warn("Couldn't read "+FILE_EXTENSION+" file ("+f.getAbsolutePath()+").",e);
+            }
+        }
+            
+    }
+    
+    @Override
+    public void write(File file) throws IOException {
+        File f = this.getFile(file);
+        try {
+            String export = crs.export(ICRSFactory.FORMAT_WKT_ESRI);
+            if(export!=null){
+                FileUtils.writeStringToFile(f, export);
+                this.source = f;
+            }
+        } catch (Exception e) {
+            logger.warn("Couldn't write "+FILE_EXTENSION+" file ("+f.getAbsolutePath()+").",e);
+            throw e;
+        }
+    }
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.tiff/src/main/java/org/gvsig/fmap/dal/file/tiff/TiffLibrary.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.tiff/src/main/java/org/gvsig/fmap/dal/file/tiff/TiffLibrary.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.tiff/src/main/java/org/gvsig/fmap/dal/file/tiff/TiffLibrary.java	(revision 43867)
@@ -98,7 +98,8 @@
                     new ImageIOFileSystemServerProviderFactory(
                             NAME,
                             DESCRIPTION,
-                            FILE_EXTENSIONS
+                            FILE_EXTENSIONS,
+                            true
                     )
             );
         } catch (Exception e) {

Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProviderFactory.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProviderFactory.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProviderFactory.java	(revision 43867)
@@ -32,14 +32,25 @@
 public class ImageIOFileSystemServerProviderFactory extends AbstractFilesystemServerExplorerProviderFactory {
 
     protected String[] fileExtensions;
+    protected boolean canCreate;
 
     public ImageIOFileSystemServerProviderFactory(
             String name, 
             String description, 
             String[] fileExtensions
         ) {
+        this(name, description, fileExtensions, false);
+    }
+
+    public ImageIOFileSystemServerProviderFactory(
+            String name, 
+            String description, 
+            String[] fileExtensions,
+            boolean canCreate
+        ) {
         super(name, description);
         this.fileExtensions = fileExtensions;
+        this.canCreate = canCreate;
     }
 
     @Override
@@ -47,7 +58,8 @@
         return new ImageIOFileSystemServerProvider(
                 this.getName(),
                 this.getDescription(),
-                this.fileExtensions
+                this.fileExtensions,
+                this.canCreate
         );
     }
 
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProvider.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.imageio/src/main/java/org/gvsig/fmap/dal/file/imageio/ImageIOFileSystemServerProvider.java	(revision 43867)
@@ -22,30 +22,139 @@
  */
 package org.gvsig.fmap.dal.file.imageio;
 
+import java.awt.image.BufferedImage;
 import java.io.File;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
+import java.util.logging.Level;
+import java.util.logging.Logger;
+import javax.imageio.IIOImage;
+import javax.imageio.ImageIO;
+import javax.imageio.ImageWriteParam;
+import javax.imageio.ImageWriter;
 
 import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.io.IOUtils;
 
 import org.gvsig.fmap.dal.DataServerExplorer;
+import org.gvsig.fmap.dal.NewDataStoreParameters;
+import org.gvsig.fmap.dal.exception.CreateException;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.raster.api.NewRasterStoreParameters;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
 import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.AbstractFilesystemServerExplorerProvider;
 import org.gvsig.fmap.dal.serverexplorer.filesystem.spi.FilesystemServerExplorerProviderServices;
+import org.gvsig.raster.lib.buffer.api.Buffer;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.dataTypes.CoercionException;
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dataTypes.DataTypesManager;
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.dynobject.DynField_v2;
 
 public class ImageIOFileSystemServerProvider extends AbstractFilesystemServerExplorerProvider {
 
     protected FilesystemServerExplorerProviderServices serverExplorer;
 
     protected String[] fileExtensions;
+    protected boolean canCreate;
 
     public ImageIOFileSystemServerProvider(
             String name, 
             String description, 
             String[] fileExtensions
         ) {
+        this(name, description, fileExtensions, false);
+    }
+    
+    public ImageIOFileSystemServerProvider(
+            String name, 
+            String description, 
+            String[] fileExtensions,
+            boolean canCreate
+        ) {
         super(name, description);
         this.fileExtensions = fileExtensions;
+        this.canCreate = canCreate;
     }
     
     @Override
+    public boolean canCreate() {
+        return canCreate;
+    }
+
+    @Override
+    public NewDataStoreParameters getCreateParameters() throws DataException {
+        if( !this.canCreate() ) {
+           throw new UnsupportedOperationException();
+        }
+        return null ; // TODO: Falta la creacion de los parametros 
+    }
+
+    @Override
+    public void create(NewDataStoreParameters parameters, boolean overwrite) throws CreateException {
+        if( !this.canCreate() ) {
+           throw new UnsupportedOperationException();
+        }
+        File output = ((FilesystemStoreParameters)parameters).getFile();
+        if( output==null ) {
+            throw new IllegalArgumentException("Parameter 'file' can't be null.");
+        }
+        Buffer buffer = ((NewRasterStoreParameters)parameters).getBuffer();
+        if( buffer==null ) {
+            throw new IllegalArgumentException("Parameter 'buffer' can't be null.");
+        }
+        BufferedImage image = buffer.getBufferedImage();
+        try {
+            ImageIO.write(image, this.getName(), output);
+        } catch (IOException ex) {
+            throw new CreateException(output.getAbsolutePath(), ex);
+        }
+        
+//        DataTypesManager dtm = ToolsLocator.getDataTypesManager();
+//        ImageWriter writer = getImageWriter();
+//        ImageWriteParam writerParams = writer.getDefaultWriteParam();
+//        Class<? extends ImageWriteParam> writerParamsClass = writerParams.getClass();
+//        for( DynField field : parameters.getDynClass().getDynFields() ) {
+//            DynField_v2 field2 = (DynField_v2) field;
+//            try {
+//                String methodName = (String) field2.getTags().get(
+//                    "ImageWriteParam", 
+//                    DataTypes.STRING
+//                );
+//                if( methodName!=null ) {
+//                    Method setter = writerParamsClass.getMethod(
+//                        methodName, 
+//                        dtm.getDefaultClass(field.getType())
+//                    );
+//                    setter.invoke(
+//                        writerParams, 
+//                        parameters.getDynValue(field.getName())
+//                    );
+//                }
+//            } catch (Exception ex) {
+//            }
+//        }
+//        FileOutputStream fos = null;
+//        try {
+//            fos = new FileOutputStream(output);
+//            writer.setOutput(fos);
+//            writer.write(null, new IIOImage(image, null, null), writerParams);
+//        } catch (Exception ex) {
+//            throw new CreateException(output.getAbsolutePath(), ex);
+//        } finally {
+//            IOUtils.closeQuietly(fos);
+//        }
+        
+    }
+    
+//    private ImageWriter getImageWriter() {
+//        return null;
+//    }
+    
+    @Override
     public int getMode() {
         return DataServerExplorer.MODE_RASTER;
     }

Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/raster/lib/legend/impl/DefaultRasterLegend.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/raster/lib/legend/impl/DefaultRasterLegend.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/raster/lib/legend/impl/DefaultRasterLegend.java	(revision 43867)
@@ -134,6 +134,7 @@
      * @param filters
      *            Filters of legend
      */
+    @SuppressWarnings("OverridableMethodCallInConstructor")
     public DefaultRasterLegend(ColorInterpretation colorInterpretation,
         Transparency transparency, OperationList filters) {
         this.transparency = transparency;
@@ -291,7 +292,7 @@
                     getFilters().setDefaultParameters(defaultParameters);
 
                     Object oColorInterpretation = null;
-                    filteredBuffer = getFilters().execute(null, bufferToDraw);
+                    filteredBuffer = getFilters().execute(taskStatus, bufferToDraw);
                     oColorInterpretation = getFilters().getParameterValue(ColoredOperation.OUTPUT_COLOR_INTERPRETATION_PARAM);
                     ColorInterpretation colorInterpretationAfterFilters = null;
                     if (oColorInterpretation != null) {
@@ -309,7 +310,7 @@
 //                        colorTableOperationParameters.setDynValue(ColoredOperation.COPY_UNPROCESSED_BANDS_PARAM,
 //                            true);
                         Buffer rgbBuffer =
-                            operationManager.execute(null, ColoredOperation.COLOR_TABLE_OPERATION_NAME, filteredBuffer,
+                            operationManager.execute(taskStatus, ColoredOperation.COLOR_TABLE_OPERATION_NAME, filteredBuffer,
                                 colorTableOperationParameters);
                         image =
                             drawRGBBuffer(graphics, rgbBuffer,
@@ -373,7 +374,7 @@
 //                        // Draw YCBCR buffer without color table
 //                        image = drawYCBCRBuffer(graphics, bufferToDraw, colorInterpretation, transparency, filters);
                     }
-                } catch (BufferOperationException e) {
+                } catch (Exception e) {
                     LOG.warn("Error drawing legend", e);
                     taskStatus.abort();
                     return;
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/fmap/mapcontext/raster/impl/DefaultRasterLayer.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/fmap/mapcontext/raster/impl/DefaultRasterLayer.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.impl/src/main/java/org/gvsig/fmap/mapcontext/raster/impl/DefaultRasterLayer.java	(revision 43867)
@@ -32,6 +32,8 @@
 import java.util.Observer;
 import java.util.Set;
 import java.util.TreeSet;
+import java.util.logging.Level;
+import java.util.logging.Logger;
 
 import org.cresques.cts.ICoordTrans;
 import org.slf4j.LoggerFactory;
@@ -39,6 +41,7 @@
 import org.gvsig.compat.print.PrintAttributes;
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.exception.ReadException;
 import org.gvsig.fmap.dal.raster.api.BandAttributeDescriptor;
 import org.gvsig.fmap.dal.raster.api.BandDescriptor;
@@ -67,6 +70,7 @@
 import org.gvsig.fmap.mapcontext.rendering.legend.events.LegendClearEvent;
 import org.gvsig.fmap.mapcontext.rendering.legend.events.SymbolLegendEvent;
 import org.gvsig.metadata.exceptions.MetadataException;
+import org.gvsig.raster.lib.buffer.api.BufferDimensions;
 import org.gvsig.raster.lib.buffer.api.BufferLocator;
 import org.gvsig.raster.lib.buffer.api.statistics.Statistics;
 import org.gvsig.raster.lib.legend.api.RasterLegend;
@@ -292,21 +296,29 @@
         rasterQuery.setClip(reprojectedViewPortEnvelope);
 
         RasterSet rasterSet = null;
+        SimpleTaskStatus taskStatus = null;
         try {
 
             long tini = System.currentTimeMillis();
 
             // TODO Task status should be used to cancel
             TaskStatusManager manager = ToolsLocator.getTaskStatusManager();
-            final SimpleTaskStatus taskStatus = manager.createDefaultSimpleTaskStatus("Draw " + getDataStore().getName());
+            taskStatus = manager.createDefaultSimpleTaskStatus("Draw " + getDataStore().getName());
+            taskStatus.setAutoremove(true);
+            taskStatus.add();
             rasterSet = getRasterStore().getRasterSet(rasterQuery);
             if (!rasterSet.isEmpty()) {
                 getLegend().draw(g, rasterSet, viewPort, taskStatus);
                 logger.debug("Layer " + this.getName() + " drawn in " + (System.currentTimeMillis() - tini)
                     + " milliseconds.");
             }
+            
 
         } catch (DataException e) {
+            if( taskStatus!=null ) {
+                taskStatus.abort();
+                taskStatus = null;
+            }
             this.setAvailable(false);
             this.setError(e);
             throw new ReadException(getName(), e);
@@ -315,6 +327,10 @@
                 DisposeUtils.dispose(rasterSet);
                 rasterSet = null;
             }
+            if( taskStatus!=null ) {
+                taskStatus.terminate();
+                taskStatus = null;
+            }
         }
 
     }
@@ -441,6 +457,16 @@
         } catch (LocatorException | DataException | CreateEnvelopeException e) {
         }
         int bands = rasterStore.getBands();
+        int rows = -1;
+        int columns = -1;
+        String pixelSize = "-/-";
+        try {
+            BufferDimensions dimensions = rasterStore.getDimensions();
+            rows = dimensions.getRows();
+            columns = dimensions.getColumns();
+            pixelSize = String.format("%.3f/%.3f", dimensions.getPixelSizeX(), dimensions.getPixelSizeY());
+        } catch (InitializeException ex) {
+        }
         I18nManager i18nManager = ToolsLocator.getI18nManager();
         LayerInformationBuilder builder = MapContextLocator.getMapContextManager().createLayerInformationBuilder();
 
@@ -455,6 +481,9 @@
         }
 
         builder.property().labelkey("_bands").value("%d", bands);
+        builder.property().labelkey("_rows").value("%d", rows);
+        builder.property().labelkey("_columns").value("%d", columns);
+        builder.property().labelkey("_pixel_size").value("%s", pixelSize);
         builder.property().labelkey("transparency").value("%d", this.getTransparency());
 
         builder.title().labelkey("_Coordenadas_geograficas");
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.bsq.app/org.gvsig.bsq.app.mainplugin/src/main/java/org/gvsig/bsq/app/BSQExtension.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.bsq.app/org.gvsig.bsq.app.mainplugin/src/main/java/org/gvsig/bsq/app/BSQExtension.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.bsq.app/org.gvsig.bsq.app.mainplugin/src/main/java/org/gvsig/bsq/app/BSQExtension.java	(revision 43867)
@@ -0,0 +1,31 @@
+
+package org.gvsig.bsq.app;
+
+import org.gvsig.andami.plugins.Extension;
+
+
+public class BSQExtension extends Extension {
+
+    @Override
+    public void initialize() {
+//        DynClass metadataDefinition = BSQLibrary.getMatadataDefinition();
+//        BSQGetLegend.register(metadataDefinition);
+//        BSQGetColorInterpretation.register(metadataDefinition); 
+//        BSQGetColorTable.register(metadataDefinition); 
+    }
+
+    @Override
+    public void execute(String actionCommand) {
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return false;
+    }
+
+    @Override
+    public boolean isVisible() {
+        return false;
+    }
+    
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.tools.app/org.gvsig.raster.tools.app.mainplugin/src/main/java/org/gvsig/raster/tools/app/mainplugin/SaveRasterLayerExtension.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.tools.app/org.gvsig.raster.tools.app.mainplugin/src/main/java/org/gvsig/raster/tools/app/mainplugin/SaveRasterLayerExtension.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.tools.app/org.gvsig.raster.tools.app.mainplugin/src/main/java/org/gvsig/raster/tools/app/mainplugin/SaveRasterLayerExtension.java	(revision 43867)
@@ -69,7 +69,7 @@
                     if (buffer != null) {
                         Buffer filteredBuffer = null;
                         try {
-                            filteredBuffer = filters.execute(buffer);
+                            filteredBuffer = filters.execute(null,buffer);
                             RasterSwingBufferManager rasterSwingBufferManager =
                                 RasterSwingBufferLocator.getSwingManager();
                             SaveBufferDialog saveBufferDialog = rasterSwingBufferManager.createSaveBufferDialog();
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.app/org.gvsig.raster.app.mainplugin/src/main/java/org/gvsig/raster/app/mainplugin/StatisticsPage.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.app/org.gvsig.raster.app.mainplugin/src/main/java/org/gvsig/raster/app/mainplugin/StatisticsPage.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.plugin/org.gvsig.raster.app/org.gvsig.raster.app.mainplugin/src/main/java/org/gvsig/raster/app/mainplugin/StatisticsPage.java	(revision 43867)
@@ -91,7 +91,8 @@
                     updateStatisticsPanel();
                 }
             });
-            panel.set(this.layer.getStatistics(null));
+            updateStatisticsPanel();
+//            panel.set(this.layer.getStatistics(null));
 
             panel.addActionListener(new ActionListener() {
 
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/statistics/DefaultStatistics.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/statistics/DefaultStatistics.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/statistics/DefaultStatistics.java	(revision 43867)
@@ -27,7 +27,6 @@
     double[][] varCov;
 
     /**
-     * @param bands
      *
      */
     public DefaultStatistics() {
@@ -167,13 +166,13 @@
         }
         init(bands);
         try {
-            status.setRangeOfValues(0, statisticsBands.length * 3);
+            status.setIndeterminate();
             status.message("Calculating statistics");
-            long cont = 0;
-
+            int count = 1;
+            int maxCount = statisticsBands.length*3;
             for (int i = 0; i < statisticsBands.length; i++) {
-                status.setCurValue(cont++);
-                if (status.isCancelled()) {
+                status.message("Calculating statistics "+count++ +"/"+maxCount);
+               if (status.isCancelled()) {
                     status.abort();
                     return;
                 }
@@ -182,18 +181,18 @@
                 }
             }
             for (int i = 0; i < statisticsBands.length; i++) {
-                status.setCurValue(cont++);
+                status.message("Calculating statistics "+count++ +"/"+maxCount);
                 if (status.isCancelled()) {
                     status.abort();
                     return;
                 }
                 for (int j = i; j < statisticsBands.length; j++) {
-                    this.varCov[i][j] = getCovariance(statisticsBands[i],bands.get(i), statisticsBands[j], bands.get(j));
+                    this.varCov[i][j] = getCovariance(status,statisticsBands[i],bands.get(i), statisticsBands[j], bands.get(j));
                 }
             }
-
+            status.setIndeterminate();
             for (int i = 0; i < statisticsBands.length; i++) {
-                status.setCurValue(cont++);
+                status.message("Calculating statistics "+count++ +"/"+maxCount);
                 if (status.isCancelled()) {
                     status.abort();
                     return;
@@ -214,12 +213,14 @@
         }
     }
 
-    private double getCovariance(StatisticsBand statisticBand1, Band band1, StatisticsBand statisticBand2, Band band2) {
+    private double getCovariance(SimpleTaskStatus  status, StatisticsBand statisticBand1, Band band1, StatisticsBand statisticBand2, Band band2) {
 
         double sigma = 0;
         int n = 0;
-
-        for (int row = 0; row < band1.getRows(); row++) {
+        int rowCount = band1.getRows();
+        status.setRangeOfValues(0, rowCount);
+        for (int row = 0; row < rowCount; row++) {
+            status.setCurValue(row);
             for (int column = 0; column < band1.getColumns(); column++) {
                 Double v1 = band1.getAsDouble(row, column);
                 if (v1 != null) {
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/AbstractPaginatedBand.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/AbstractPaginatedBand.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/AbstractPaginatedBand.java	(revision 43867)
@@ -30,7 +30,8 @@
     protected BandPageManager pageManager;
     private boolean loaded;
 
-    protected static final int MAX_PREFERED_SIZE = 10485760; // 10MB;
+    // protected static final int MAX_PREFERED_SIZE = 10485760; // 10MB;
+    protected static final int MAX_PREFERED_SIZE = 2621440; // 2.5MB;
 
     /**
      * @param rows
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/DefaultBufferManager.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/DefaultBufferManager.java	(revision 43866)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.library/org.gvsig.raster/org.gvsig.raster.lib/org.gvsig.raster.lib.buffer.impl/src/main/java/org/gvsig/raster/lib/buffer/impl/DefaultBufferManager.java	(revision 43867)
@@ -55,7 +55,7 @@
 import org.gvsig.tools.dynobject.DynObject;
 import org.gvsig.tools.folders.FoldersManager;
 import org.gvsig.tools.locator.LocatorException;
-import org.gvsig.tools.task.TaskStatus;
+import org.gvsig.tools.task.SimpleTaskStatus;
 
 /**
  * @author fdiaz
@@ -655,7 +655,7 @@
     }
 
     @Override
-    public Buffer execute(TaskStatus status, String name, Buffer buffer, DynObject parameters) throws BufferOperationException {
+    public Buffer execute(SimpleTaskStatus status, String name, Buffer buffer, DynObject parameters) throws BufferOperationException {
         OperationFactory factory = getOperationFactory(name);
         Operation operation = factory.create();
         return operation.execute(status, buffer, parameters);
